init python:
    def persistent_to_filters():
        global filters_filter
        import copy
        filters_filter = copy.deepcopy(persistent.filters_filter)  
    
    def filters_to_persistent_func():
        import copy
        persistent.filters_filter = copy.deepcopy(filters_filter) 
    
    def filter_filters_lst(lst):
        res = []
        for i in lst:
            ok = True
            for p in filters_filter["+"]:
                if  i not in tag_filters[p]:
                    ok = False
            for p in filters_filter["-"]:
                if  i in tag_filters[p]:
                    ok = False
            if ok:
                res += [i]
        return res

    def filter_filters_add_func(lst, name):
        filters_filter[lst] += [name]
        renpy.restart_interaction()

    def filter_filters_del_func(lst, name):
        filters_filter[lst].remove(name)
        renpy.restart_interaction()

    def filter_select_func(id):
        global filter_selected
        filter_selected = id
        renpy.restart_interaction()

    def filter_restart_func():
        filters_convert()
        renpy.music.stop()
        renpy.utter_restart()


    filters_to_persistent = renpy.curry(filters_to_persistent_func)
    filter_filters_add = renpy.curry(filter_filters_add_func)
    filter_filters_del = renpy.curry(filter_filters_del_func)
    filter_select = renpy.curry(filter_select_func)
    filter_restart = renpy.curry(filter_restart_func)
    filter_state = {}

    def filters_convert():
        persistent.filters = []
        for filter, state in filter_state.iteritems():
            persistent.filters += [{"id":filter,"is_active":state}]

    if  not persistent.filters_filter:
        persistent.filters_filter = {"+":[], "-":[]}

    try:
        filters_filter
    except:
        persistent_to_filters()

init 9000 python:

    if persistent.filters:
        for i in persistent.filters:
            filter_state[i["id"]] = i["is_active"]
    else:
        persistent.filters = []
        for f in filters.keys():
            filter_state[f] = False

    for item in persistent.filters[:]:
        if  item["id"] in filters and item["id"] in renpy.store.__dict__:
            if  item["is_active"]:
                renpy.store.__dict__[item["id"]]()
        else:
            persistent.filters.remove(item)

    if not persistent.rad_filters_menu_settings:
        persistent.rad_filters_menu_settings = {
            "author_tags": False,
            "quick_switch": True,
            "swap_button_actions": False
        }

    for m in filters:
        if not m in filter_links:
            filter_links[m] = {}
        if not m in filter_tags:
            filter_tags[m] = ["special:tag_me"]
        filter_tags[m] += ["author:"+m.split("__")[0] if m.find("__")!=-1 else "author:unknown"]
    
    for m in filter_tags:
        if not m in filters:
            del filter_tags[m]
    
    tag_filters = {t:[m for m in filters if t in filter_tags[m]] for t in set(sum(filter_tags.values(),[]))}
    
    filter_tags_grouped = {}
    
    for filter, tags in filter_tags.iteritems():
        if filter not in filter_tags_grouped:
            filter_tags_grouped[filter] = {}
        for tag in tags:
            if tag.split(":")[0] not in filter_tags_grouped[filter]:
                filter_tags_grouped[filter][tag.split(":")[0]] = []
            filter_tags_grouped[filter][tag.split(":")[0]] += [tag.split(":")[-1]]

    for filter, tags_grouped in filter_tags_grouped.iteritems():
        for group, tags in sorted(tags_grouped.iteritems()):
            for tag in sorted(tags):
                if group in tags_translate and tag in tags_translate[group]:
                    filter_tags_grouped[filter][group] += [tags_translate[group][tag]]
                    filter_tags_grouped[filter][group].remove(tag)
    
screen filters_menu_rad():
    tag menu
    modal True
    python:
        what_tag_filters = [(k,len(filter_filters_lst(v))) for k,v in tag_filters.iteritems() if k not in filters_filter["+"] and len(filter_filters_lst(v))]
        what_items = [(k, "%s %s" %( "" if k.find("__") == -1 else "{color=#117743}[["+k.split("__")[0]+"]{/color}", __(filters[k]) )) for k in filter_filters_lst(filters.keys())]
        what_tag_filter_groups = sorted(list(set([i.split(":")[0] for i,n in what_tag_filters if i.find(":")!=-1])))
        basic = {
            "current_menu": "filters_menu_rad",
            "prev_link": "main_menu",
            "left_link": "mods_menu_settings_rad",
            "right_link": "mods_menu_rad",
            "left_args": {
                "prev_menu": "filters_menu_rad"
            }
        }
    frame:
        background "mod_bg"
        use rad_preferences_header(**basic)
        textbutton "Применить":
            style "log_button"
            text_style "settings_link"
            xalign 0.98
            yalign 0.92
            action filter_restart()
        add "side_menu_bg":
            alpha 0.9
            xalign -0.08
            yalign 0.61
        side "c b r":
            area (0.006, 0.24, 0.234, 0.605)
            viewport:
                id "left"
                draggable True
                mousewheel True
                scrollbars None
                yinitial 0.0
                has hbox
                null width 5
                vbox:
                    xfill True
                    hbox:
                        if persistent.filters_filter != filters_filter:
                            textbutton "★":
                                style "log_button"
                                text_style "fav_icon"
                                action (filters_to_persistent(), Show("notify_prompt",message="Текущий набор фильтров тэгов сохранён."))
                        text ("Фильтров тэгов: %d"%len(sum(filters_filter.values(),[]))):
                            style "settings_text"

                    for t in filters_filter:
                        for name in sorted(filters_filter[t]):
                            hbox:
                                xpos 35
                                textbutton "X":
                                    style "log_button"
                                    text_style "settings_text_small"
                                    action filter_filters_del(t, name)
                                text ("%s %s: %s"%(t,(tag_groups_translate[name.split(":")[0]] if name.split(":")[0] in tag_groups_translate else name.split(":")[0]),(tags_translate[name.split(":")[0]][name.split(":")[-1]] if name.split(":")[0] in tag_groups_translate and name.split(":")[0] in tags_translate and name.split(":")[-1] in tags_translate[name.split(":")[0]] else name.split(":")[-1]))):
                                    style "settings_text_small"

                    text ("Фильтров: %d"%len(what_items)):
                        style "settings_text"

                    for g in what_tag_filter_groups:
                        if not (g == "author" and not persistent.rad_filters_menu_settings["author_tags"]):
                            text ("%s:" % (tag_groups_translate[g] if g in tag_groups_translate else g)):
                                style "settings_text"
                                xpos 35
                            for name,n in sorted(what_tag_filters):
                                if name.startswith(g+":"):
                                    hbox:
                                        xpos 70
                                        textbutton "-":
                                            style "log_button"
                                            text_style "settings_text_small"
                                            action filter_filters_add("-", name)
                                        textbutton "+":
                                            style "log_button"
                                            text_style "settings_text_small"
                                            action filter_filters_add("+", name)
                                        textbutton ("%s (%d)"%((tags_translate[g][name.split(":")[-1]] if g in tag_groups_translate and g in tags_translate and name.split(":")[-1] in tags_translate[g] else name.split(":")[-1]),n)):
                                            xfill True
                                            right_margin 100
                                            style "log_button"
                                            text_style "settings_text_small"
                null width 5
            use scrollbars("left")

        if filters:
            side "c b r":
                area (0.27, 0.24, 0.47, 0.70)
                viewport:
                    id "center"
                    draggable True
                    mousewheel True
                    scrollbars None
                    yinitial 0.0
                    has vbox
                    for lbl, name  in sorted(what_items,key=lambda (i,j):(j,i)):
                        hbox:
                            null width 5
                            if persistent.rad_filters_menu_settings["quick_switch"]:
                                if persistent.rad_filters_menu_settings["swap_button_actions"]:
                                    imagebutton:
                                        ypos 5
                                        idle ("checkbox idle%s" % (" checked" if filter_state[lbl] else ""))
                                        hover ("checkbox hover%s" % (" checked" if filter_state[lbl] else ""))
                                        action filter_select(lbl)
                                else:
                                    imagebutton:
                                        ypos 5
                                        idle ("checkbox idle%s" % (" checked" if filter_state[lbl] else ""))
                                        hover ("checkbox hover%s" % (" checked" if filter_state[lbl] else ""))
                                        action (ToggleDict(filter_state, lbl), redraw_current_screen())
                            if persistent.rad_filters_menu_settings["swap_button_actions"]:
                                textbutton name:
                                    style "log_button"
                                    text_style "settings_text"
                                    action (ToggleDict(filter_state, lbl), redraw_current_screen())
                            else:
                                textbutton name:
                                    style "log_button"
                                    text_style "settings_text"
                                    action filter_select(lbl)
                use scrollbars("center")


        if filter_selected:
            add "side_menu_bg":
                alpha 0.9
                xalign 1.07
                yalign 0.61
            side "c b r":
                area (0.761, 0.24, 0.234, 0.605)
                viewport:
                    id "right"
                    draggable True
                    mousewheel True
                    scrollbars None
                    yinitial 0.0
                    has hbox
                    null width 5
                    vbox:
                        xfill True
                        text filters[filter_selected]:
                            style "settings_text"
                        for g in sorted(filter_tags_grouped[filter_selected]):
                            text ("{color=#117743}%s:{/color} %s" % ( (tag_groups_translate[g] if g in tag_groups_translate else g), (", ".join(filter_tags_grouped[filter_selected][g])))):
                                style "settings_text_small"
                        vbox:
                            xfill True
                            textbutton ("%s" % ("Отключить" if filter_state[filter_selected] else "Включить")):
                                xalign 0.5
                                style "log_button"
                                text_style "settings_text"
                                action (ToggleDict(filter_state, filter_selected), redraw_current_screen())
                            for link, options in filter_links[filter_selected].iteritems():
                                if options["type"] == "screen":
                                    textbutton options["name"]:
                                        xalign 0.5
                                        style "log_button"
                                        text_style "settings_text"
                                        action ShowMenu(options["label"], **options["args"])
                                elif options["type"] == "label":
                                    textbutton options["name"]:
                                        xalign 0.5
                                        style "log_button"
                                        text_style "settings_text"
                                        action (SetField(persistent, "jump_to", options["label"]), SetVariable(backdrop, 'prologue'), Start())
                    null width 5
                use scrollbars("right")
