init python:
    def persistent_to_mods():
        global mods_filter
        import copy
        mods_filter = copy.deepcopy(persistent.mods_filter)  
    
    def mods_to_persistent_func():
        import copy
        persistent.mods_filter = copy.deepcopy(mods_filter)
    
    def filter_mods_lst(lst):
        res = []
        for i in lst:
            ok = True
            for p in mods_filter["+"]:
                if  i not in tag_mods[p]:
                    ok = False
            for p in mods_filter["-"]:
                if  i in tag_mods[p]:
                    ok = False
            if ok:
                res += [i]
        return res

    def filter_mods_add_func(lst, name):
        mods_filter[lst] += [name]
        renpy.restart_interaction()

    def filter_mods_del_func(lst, name):
        mods_filter[lst].remove(name)
        renpy.restart_interaction()

    def mod_select_func(id):
        global mod_selected
        mod_selected = id
        renpy.restart_interaction()

    mod_select = renpy.curry(mod_select_func)
    mods_to_persistent = renpy.curry(mods_to_persistent_func)
    filter_mods_add = renpy.curry(filter_mods_add_func)
    filter_mods_del = renpy.curry(filter_mods_del_func)

    if not persistent.mods_filter:
        persistent.mods_filter = {"+":[], "-":[]}

    try:
        mods_filter
    except:
        persistent_to_mods()

init 9000 python:
    if not persistent.rad_mods_menu_settings:
        persistent.rad_mods_menu_settings = {
            "author_tags": False,
            "quick_launch": True,
            "swap_button_actions": False
        }

    for m in mods:
        if not m in mod_links:
            mod_links[m] = {}
        if not m in mod_tags:
            mod_tags[m] = ["special:tag_me"]
        mod_tags[m] += ["author:"+m.split("__")[0] if m.find("__")!=-1 else "author:unknown"]
    
    for m in mod_tags:
        if not m in mods:
            del mod_tags[m]
    
    tag_mods = {t:[m for m in mods if t in mod_tags[m]] for t in set(sum(mod_tags.values(),[]))}
    
    mod_tags_grouped = {}

    for mod, tags in mod_tags.iteritems():
        if mod not in mod_tags_grouped:
            mod_tags_grouped[mod] = {}
        for tag in tags:
            if tag.split(":")[0] not in mod_tags_grouped[mod]:
                mod_tags_grouped[mod][tag.split(":")[0]] = []
            mod_tags_grouped[mod][tag.split(":")[0]] += [tag.split(":")[-1]]

    for mod, tags_grouped in mod_tags_grouped.iteritems():
        for group, tags in sorted(tags_grouped.iteritems()):
            for tag in sorted(tags):
                if group in tags_translate and tag in tags_translate[group]:
                    mod_tags_grouped[mod][group] += [tags_translate[group][tag]]
                    mod_tags_grouped[mod][group].remove(tag)

screen mods_menu_rad():
    tag menu
    modal True
    python:
        what_tag_filters = [(k,len(filter_mods_lst(v))) for k,v in tag_mods.iteritems() if k not in mods_filter["+"] and len(filter_mods_lst(v))]
        what_items = [(k, ("%s %s" %( "" if k.find("__") == -1 else "{color=#117743}[["+k.split("__")[0]+"]{/color}",mods[k]))) for k in filter_mods_lst(mods.keys())]
        what_tag_filter_groups = sorted(list(set([i.split(":")[0] for i,n in what_tag_filters if i.find(":")!=-1])))
        basic = {
            "current_menu": "mods_menu_rad",
            "prev_link": "main_menu",
            "left_link": "filters_menu_rad",
            "right_link": "mods_menu_settings_rad",
            "right_args": {
                "prev_menu": 'mods_menu_rad'
            }
        }
    frame:
        background "mod_bg"
        use rad_preferences_header(**basic)
        add "side_menu_bg":
            alpha 0.9
            xalign -0.08
            yalign 0.61
        side "c b r":
            area (0.006, 0.24, 0.234, 0.605)
            viewport:
                id "left"
                draggable True
                mousewheel True
                scrollbars None
                yinitial 0.0
                has hbox
                null width 5
                vbox:
                    xfill True
                    hbox:
                        if persistent.mods_filter != mods_filter:
                            textbutton "★":
                                style "log_button"
                                text_style "fav_icon"
                                action (mods_to_persistent(), Show("notify_prompt",message="Текущий набор фильтров тэгов сохранён."))
                        text ("Фильтров тэгов: %d"%len(sum(mods_filter.values(),[]))):
                            style "settings_text"

                    for t in mods_filter:
                        for name in sorted(mods_filter[t]):
                            hbox:
                                xpos 35
                                textbutton "X":
                                    style "log_button"
                                    text_style "settings_text_small"
                                    action filter_mods_del(t, name)
                                text ("%s %s: %s"%(t,(tag_groups_translate[name.split(":")[0]] if name.split(":")[0] in tag_groups_translate else name.split(":")[0]),(tags_translate[name.split(":")[0]][name.split(":")[-1]] if name.split(":")[0] in tag_groups_translate and name.split(":")[0] in tags_translate and name.split(":")[-1] in tags_translate[name.split(":")[0]] else name.split(":")[-1]))):
                                    style "settings_text_small"

                    text ("Модов: %d"%len(what_items)):
                        style "settings_text"

                    for g in what_tag_filter_groups:
                        if not (g == "author" and not persistent.rad_mods_menu_settings["author_tags"]):
                            text ("%s:" % (tag_groups_translate[g] if g in tag_groups_translate else g)):
                                style "settings_text"
                                xpos 35
                            for name,n in sorted(what_tag_filters):
                                if name.startswith(g+":"):
                                    hbox:
                                        xpos 70
                                        textbutton "-":
                                            style "log_button"
                                            text_style "settings_text_small"
                                            action filter_mods_add("-", name)
                                        textbutton "+":
                                            style "log_button"
                                            text_style "settings_text_small"
                                            action filter_mods_add("+", name)
                                        textbutton ("%s (%d)"%((tags_translate[g][name.split(":")[-1]] if g in tag_groups_translate and g in tags_translate and name.split(":")[-1] in tags_translate[g] else name.split(":")[-1]),n)):
                                            xfill True
                                            right_margin 100
                                            style "log_button"
                                            text_style "settings_text_small"
                null width 5
            use scrollbars("left")

        if mods:
            side "c b r":
                area (0.27, 0.24, 0.47, 0.70)
                viewport:
                    id "center"
                    draggable True
                    mousewheel True
                    scrollbars None
                    yinitial 0.0
                    has vbox
                    for lbl, name  in sorted(what_items,key=lambda (i,j):(j,i)):
                        hbox:
                            null width 5
                            if persistent.rad_mods_menu_settings["quick_launch"]:
                                if persistent.rad_mods_menu_settings["swap_button_actions"]:
                                    imagebutton:
                                        ypos 10
                                        idle "vthumb idle"
                                        hover "vthumb hover"
                                        action mod_select(lbl)
                                else:   
                                    imagebutton:
                                        ypos 10
                                        idle "vthumb idle"
                                        hover "vthumb hover"
                                        action (SetField(persistent, "jump_to", lbl), SetVariable(backdrop, 'prologue'), Start())
                            if persistent.rad_mods_menu_settings["swap_button_actions"]:
                                textbutton name:
                                    style "log_button"
                                    text_style "settings_text"
                                    action (SetField(persistent, "jump_to", lbl), SetVariable(backdrop, 'prologue'), Start())
                            else:
                                textbutton name:
                                    style "log_button"
                                    text_style "settings_text"
                                    action mod_select(lbl)
                use scrollbars("center")

        if mod_selected:
            add "side_menu_bg":
                alpha 0.9
                xalign 1.07
                yalign 0.61
            side "c b r":
                area (0.761, 0.24, 0.234, 0.605)
                viewport:
                    id "right"
                    draggable True
                    mousewheel True
                    scrollbars None
                    yinitial 0.0
                    has hbox
                    null width 5
                    vbox:
                        xfill True
                        text mods[mod_selected]:
                            style "settings_text"
                        for g in sorted(mod_tags_grouped[mod_selected]):
                            text ("{color=#117743}%s:{/color} %s" % ( (tag_groups_translate[g] if g in tag_groups_translate else g), (", ".join(mod_tags_grouped[mod_selected][g])))):
                                style "settings_text_small"                        
                        vbox:
                            xalign 0.5
                            textbutton "Запустить":
                                style "log_button"
                                text_style "settings_text"
                                action (SetField(persistent, "jump_to", mod_selected), SetVariable(backdrop, 'prologue'), Start())
                            for link, options in mod_links[mod_selected].iteritems():
                                if options["type"] == "screen":
                                    textbutton options["name"]:
                                        xalign 0.5
                                        style "log_button"
                                        text_style "settings_text"
                                        action ShowMenu(options["label"], **options["args"])
                                elif options["type"] == "label":
                                    textbutton options["name"]:
                                        xalign 0.5
                                        style "log_button"
                                        text_style "settings_text"
                                        action (SetField(persistent, "jump_to", options["label"]), SetVariable(backdrop, 'prologue'), Start())
                    null width 5
                use scrollbars("right")
