init -1001 python:
    tag_groups_translate = {
        "character": "Персонажи",
        "author": "Автор",
        "gameplay": "Геймплей",
        "length": "Продолжительность",
        "translation": "Перевод",
        "protagonist": "Протагонист",
        "special": "Особые тэги",
        "type": "Тип",
        "version": "Версия"
    }

    tags_translate = {
        "author": {
            "unknown": "неизвестен"
        },
        "character": {
            "new character": "новый персонаж"
        },
        "protagonist": {
            "male": "парень",
            "female": "девушка"
        },
        "special": {
            "tag_me": "нет тэгов"
        },
        "type": {
            "ui": "интерфейс",
            "image": "изображения",
            "menu": "меню",
            "widget": "виджет",
            "text": "текстовый фильтр"
        }
    }

python early:
    mods = {}
    filters = {}
    mod_tags = {}
    filter_tags = {}
    mod_settings = {}
    filter_settings = {}
    mod_links = {}
    filter_links = {}
    mod_selected = None
    filter_selected = None

init python:
    style.base_font = Style(style.default)
    style.base_font.font  = "fonts/calibri.ttf"
    style.base_font.size = 28
    style.base_font.line_spacing = 2

    style.fav_icon = Style(style.default)
    style.fav_icon.size = 24
    style.fav_icon.color = "#4d2e19"
    style.fav_icon.hover_color = "#a27146"

    style.settings_header = Style(style.base_font)
    style.settings_header.font  = "fonts/corbel.ttf"
    style.settings_header.size = 50
    style.settings_header.color = "#4d2e19"
    style.settings_header.hover_color = "#a27146"
    
    style.settings_text = Style(style.settings_header)
    style.settings_text.size = 36
    style.settings_text.selected_color = "#4d2e19"
    style.settings_text.hover_color = "#a27146"

    style.settings_link = Style(style.base_font)
    style.settings_link.font  = "mods_rad/fonts/gothic.ttf"
    style.settings_link.size = 60
    style.settings_link.kerning = 3
    style.settings_link.color = "#909ca3"
    style.settings_link.hover_color = "#ffffff"
    style.settings_link.selected_color = "#909ca3"
    style.settings_link.selected_idle_color = "#909ca3"
    style.settings_link.selected_hover_color = "#ffffff"
    style.settings_link.insensitive_color = "#909ca3"

    style.settings_text_small = Style(style.settings_text)
    style.settings_text_small.size = 24

    menu_header_links = {
        "mods_menu_settings_rad": {
            "title": "НАСТРОЙКИ МЕНЮ"
        },
        "filters_menu_rad": {
            "title": "ФИЛЬТРЫ"
        },
        "mods_menu_rad": {
            "title": "МОДЫ"
        }
    }
    renpy.display.screen.screens[("mods",None)] = renpy.display.screen.screens[("mods_menu_rad",None)]
    renpy.display.screen.screens[("filters",None)] = renpy.display.screen.screens[("filters_menu_rad",None)]
    redraw_current_screen = renpy.curry(renpy.restart_interaction)


init:
    $ checkbox = "mods_rad/images/leaf.png"
    $ vthumb = "mods_rad/images/vthumb.png"
    image checkbox = checkbox
    image checkbox idle = im.MatrixColor(checkbox, im.matrix.opacity(0.6) * im.matrix.desaturate())
    image checkbox hover = im.MatrixColor(checkbox, im.matrix.opacity(1) * im.matrix.desaturate())
    image checkbox idle checked = im.MatrixColor(checkbox, im.matrix.opacity(0.8))
    image checkbox hover checked = im.MatrixColor(checkbox, im.matrix.opacity(1))
    image mod_bg = "mods_rad/images/bg.jpg"
    image side_menu_bg = "mods_rad/images/side_menu.png"
    image star = "mods_rad/images/star.png"
    image none = "mods_rad/images/none.png"
    image vthumb = vthumb
    image vthumb idle = im.MatrixColor(im.Flip(vthumb, horizontal=True), im.matrix.opacity(0.6))
    image vthumb hover = im.Flip(vthumb, horizontal=True)

screen notify_prompt(message):
    modal True
    image get_image("gui/o_rly/base.png")
    text message:
        text_align 0.5
        yalign 0.46
        xalign 0.5
        color "#64483c"
        font "fonts/corbel.ttf"
        size 30
    textbutton "Продолжить →":
        text_size 60
        style "log_button"
        text_style "settings_link"
        yalign 0.65
        xalign 0.5
        action Hide("notify_prompt")

screen rad_preferences_header(current_menu, prev_link, left_link=None, right_link=None, left_args={}, right_args={}):
    if left_link != None:
        textbutton menu_header_links[left_link]["title"]:
            style "log_button"
            text_style "settings_link"
            xalign 0.02
            yalign 0.08
            action Show(left_link, **left_args)
    hbox:
        xalign 0.5
        yalign 0.08
        add "star" yalign 0.5
        null width 30
        text menu_header_links[current_menu]["title"]:
            style "settings_link"
            color "#ffffff"
        null width 30
        add "star" yalign 0.5
    if right_link != None:
        textbutton menu_header_links[right_link]["title"]:
            style "log_button"
            text_style "settings_link"
            xalign 0.98
            yalign 0.08
            action Show(right_link, **right_args)
    textbutton "← Назад":
            style "log_button"
            text_style "settings_link"
            xalign 0.015
            yalign 0.92
            action Show(prev_link)

screen scrollbars(id):
    bar:
        value XScrollValue(id)
        left_bar "none"
        right_bar "none"
        thumb "none"
        hover_thumb "none"
    vbar:
        value YScrollValue(id)
        bottom_bar "none"
        top_bar "none"
        thumb "vthumb"
        thumb_offset -12

screen mods_menu_settings_rad(prev_menu="main_menu"):
    tag menu
    modal True
    python:
        basic = {
            "current_menu": "mods_menu_settings_rad",
            "left_link": "mods_menu_rad",
            "right_link": "filters_menu_rad"
        }
    frame:
        background "mod_bg"
        use rad_preferences_header(prev_link=prev_menu, **basic)
        side "c b r":
            area (0.27, 0.24, 0.47, 0.70)
            viewport:
                id "center"
                draggable True
                mousewheel True
                scrollbars None
                yinitial 0.0
                grid 1 6:
                    xfill True
                    spacing 15
                    vbox:
                        xfill True
                        text "Тэги авторов":
                            style "settings_header"
                            xalign 0.5
                        text "Автоматически добавляет авторов в список тэгов.":
                            style "settings_text_small"
                            xalign 0.5
                    grid 2 1:
                        xfill True
                        xanchor -0.05
                        hbox:
                            imagebutton:
                                ypos 0.12
                                idle ("checkbox idle%s" % (" checked" if persistent.rad_mods_menu_settings["author_tags"] else ""))
                                hover ("checkbox hover%s" % (" checked" if persistent.rad_mods_menu_settings["author_tags"] else ""))
                                action (ToggleDict(persistent.rad_mods_menu_settings, "author_tags"))
                            textbutton "Для модов":
                                style "log_button"
                                text_style "settings_text"
                                action (ToggleDict(persistent.rad_mods_menu_settings, "author_tags"))
                        hbox:
                            imagebutton:
                                ypos 0.12
                                idle ("checkbox idle%s" % (" checked" if persistent.rad_filters_menu_settings["author_tags"] else ""))
                                hover ("checkbox hover%s" % (" checked" if persistent.rad_filters_menu_settings["author_tags"] else ""))
                                action (ToggleDict(persistent.rad_filters_menu_settings, "author_tags"))
                            textbutton "Для фильтров":
                                style "log_button"
                                text_style "settings_text"
                                action (ToggleDict(persistent.rad_filters_menu_settings, "author_tags"))
                    vbox:
                        xfill True
                        text "Кнопка быстрого запуска":
                            style "settings_header"
                            xalign 0.5
                        text "Включает кнопку для быстрого запуска/переключения мода.":
                            style "settings_text_small"
                            xalign 0.5
                    grid 2 1:
                        xfill True
                        xanchor -0.05
                        hbox:
                            imagebutton:
                                ypos 0.12
                                idle ("checkbox idle%s" % (" checked" if persistent.rad_mods_menu_settings["quick_launch"] else ""))
                                hover ("checkbox hover%s" % (" checked" if persistent.rad_mods_menu_settings["quick_launch"] else ""))
                                action (ToggleDict(persistent.rad_mods_menu_settings, "quick_launch"))
                            textbutton "Для модов":
                                style "log_button"
                                text_style "settings_text"
                                action (ToggleDict(persistent.rad_mods_menu_settings, "quick_launch"))
                        hbox:
                            imagebutton:
                                ypos 0.12
                                idle ("checkbox idle%s" % (" checked" if persistent.rad_filters_menu_settings["quick_switch"] else ""))
                                hover ("checkbox hover%s" % (" checked" if persistent.rad_filters_menu_settings["quick_switch"] else ""))
                                action (ToggleDict(persistent.rad_filters_menu_settings, "quick_switch"))
                            textbutton "Для фильтров":
                                style "log_button"
                                text_style "settings_text"
                                action (ToggleDict(persistent.rad_filters_menu_settings, "quick_switch"))
                    vbox:
                        xfill True
                        text "Поменять местами действия кнопок":
                            style "settings_header"
                            xalign 0.5
                        text "Меняет местами кнопку быстрого запуска и кнопку с информацией о моде.":
                            style "settings_text_small"
                            xalign 0.5
                    grid 2 1:
                        xfill True
                        xanchor -0.05
                        hbox:
                            imagebutton:
                                ypos 0.12
                                idle ("checkbox idle%s" % (" checked" if persistent.rad_mods_menu_settings["swap_button_actions"] else ""))
                                hover ("checkbox hover%s" % (" checked" if persistent.rad_mods_menu_settings["swap_button_actions"] else ""))
                                action (ToggleDict(persistent.rad_mods_menu_settings, "swap_button_actions"))
                            textbutton "Для модов":
                                style "log_button"
                                text_style "settings_text"
                                action (ToggleDict(persistent.rad_mods_menu_settings, "swap_button_actions"))
                        hbox:
                            imagebutton:
                                ypos 0.12
                                idle ("checkbox idle%s" % (" checked" if persistent.rad_filters_menu_settings["swap_button_actions"] else ""))
                                hover ("checkbox hover%s" % (" checked" if persistent.rad_filters_menu_settings["swap_button_actions"] else ""))
                                action (ToggleDict(persistent.rad_filters_menu_settings, "swap_button_actions"))
                            textbutton "Для фильтров":
                                style "log_button"
                                text_style "settings_text"
                                action (ToggleDict(persistent.rad_filters_menu_settings, "swap_button_actions"))
            use scrollbars("center")
